diff --git a/test/unit/commands/init/prompts_test.rb b/test/unit/commands/init/prompts_test.rb
index 734b955..08d1b3b 100644
--- a/test/unit/commands/init/prompts_test.rb
+++ b/test/unit/commands/init/prompts_test.rb
@@ -46,7 +46,8 @@ class InitPromptsTest < Minitest::Test
       "timeouts" => Hive::Commands::Init::Prompts::LIMIT_KEYS.each_with_object({}) do |k, h|
         h[k] = Hive::Config::DEFAULTS["timeout_sec"][k]
       end,
-      "daemon_enabled" => true
+      "daemon_enabled" => true,
+      "model_overrides" => {}
     }
   end
 
@@ -62,8 +63,29 @@ class InitPromptsTest < Minitest::Test
   #  15. confirmation Y/n
   # Each line is one answer; blank line = accept default.
   def interactive_input(planning: "", development: "", reviewers: "",
-                        triage_bias: "", limits: ([ "" ] * 9), daemon: "", confirm: "")
-    [ planning, development, reviewers, triage_bias, *limits, daemon, confirm ].map { |a| "#{a}\n" }.join
+                        triage_bias: "", limits: ([ "" ] * 9), daemon: "",
+                        models: ([ "" ] * 2), confirm: "")
+    # U4/R11: two optional model-override prompts (planning + development
+    # agent) sit between the daemon question and the final confirmation.
+    # The two trailing blanks are SURPLUS padding: flows without a
+    # re-prompt cascade leave them unread; flows with a cascade consume
+    # them in the model-override slots. This keeps every existing script's
+    # token budget intact regardless of cascade length.
+    [ planning, development, reviewers, triage_bias, *limits, daemon,
+      *models, confirm, "", "" ].map { |a| "#{a}\n" }.join
+  end
+
+  def test_interactive_model_overrides_recorded_for_both_agents
+    prompts, _output = make_prompts(interactive_input(models: ["claude-opus-4-6", "gpt-5.1-codex"]))
+    answers = prompts.collect
+    assert_equal({ "claude" => "claude-opus-4-6", "codex" => "gpt-5.1-codex" },
+                 answers["model_overrides"])
+  end
+
+  def test_interactive_model_overrides_blank_means_provider_default
+    prompts, _output = make_prompts(interactive_input)
+    answers = prompts.collect
+    assert_empty answers["model_overrides"]
   end
 
   # --- non-TTY: short-circuit to defaults ----------------------------------
@@ -141,7 +163,7 @@ class InitPromptsTest < Minitest::Test
     # 16 reads total: planning (invalid + retry) + dev + reviewers
     # + triage bias + 9 limits + daemon + confirm. Each blank line
     # accepts the default.
-    raw = ([ "nonexistent", "claude" ] + ([ "" ] * 14)).join("\n") + "\n"
+    raw = ([ "nonexistent", "claude" ] + ([ "" ] * 16)).join("\n") + "\n"
     prompts, output, _summary = make_prompts(raw)
     answers = prompts.collect
     assert_equal "claude", answers["planning_agent"]
@@ -149,7 +171,7 @@ class InitPromptsTest < Minitest::Test
   end
 
   def test_interactive_planning_agent_index_out_of_range_reprompts
-    raw = ([ "7", "claude" ] + ([ "" ] * 14)).join("\n") + "\n"
+    raw = ([ "7", "claude" ] + ([ "" ] * 16)).join("\n") + "\n"
     prompts, output, _summary = make_prompts(raw)
     answers = prompts.collect
     assert_equal "claude", answers["planning_agent"]
@@ -189,7 +211,7 @@ class InitPromptsTest < Minitest::Test
     # Build the input manually since interactive_input doesn't allow
     # multi-line reviewer answers cleanly. Trailing values are triage
     # bias, nine limits, daemon, and confirm.
-    input = ([ "", "", "7", "1,2" ] + ([ "" ] * 12)).join("\n") + "\n"
+    input = ([ "", "", "7", "1,2" ] + ([ "" ] * 14)).join("\n") + "\n"
     prompts, output = make_prompts(input)
     answers = prompts.collect
     assert_equal %w[claude-ce-code-review codex-ce-code-review], answers["enabled_reviewers"]
@@ -197,7 +219,7 @@ class InitPromptsTest < Minitest::Test
   end
 
   def test_interactive_reviewers_unknown_name_reprompts
-    input = ([ "", "", "nope", "1" ] + ([ "" ] * 12)).join("\n") + "\n"
+    input = ([ "", "", "nope", "1" ] + ([ "" ] * 14)).join("\n") + "\n"
     prompts, output = make_prompts(input)
     answers = prompts.collect
     assert_equal %w[claude-ce-code-review], answers["enabled_reviewers"]
@@ -231,7 +253,7 @@ class InitPromptsTest < Minitest::Test
   end
 
   def test_interactive_triage_bias_unknown_reprompts
-    input = ([ "", "", "", "bad", "2" ] + ([ "" ] * 11)).join("\n") + "\n"
+    input = ([ "", "", "", "bad", "2" ] + ([ "" ] * 13)).join("\n") + "\n"
     prompts, output = make_prompts(input)
     answers = prompts.collect
     assert_equal "safetyist", answers["triage_bias"]
@@ -268,7 +290,7 @@ class InitPromptsTest < Minitest::Test
 
   def test_interactive_limits_partial_pair_uses_default_for_missing_side
     # ",900" → keep budget default, override timeout
-    limits = [ ",900" ] + ([ "" ] * 8)
+    limits = [ ",900" ] + ([ "" ] * 10)
     prompts, _output = make_prompts(interactive_input(limits: limits))
     answers = prompts.collect
     assert_equal Hive::Config::DEFAULTS["budget_usd"]["brainstorm"], answers["budgets"]["brainstorm"]
@@ -278,7 +300,7 @@ class InitPromptsTest < Minitest::Test
   def test_interactive_limits_zero_budget_reprompts
     # First answer 0,300 fails validation → re-prompt; second answer 10,600 accepted.
     # Trailing pair is daemon + confirm (both blank → daemon enabled, confirm yes).
-    input = ([ "", "", "", "", "0,300", "10,600" ] + ([ "" ] * 10)).join("\n") + "\n"
+    input = ([ "", "", "", "", "0,300", "10,600" ] + ([ "" ] * 12)).join("\n") + "\n"
     prompts, output = make_prompts(input)
     answers = prompts.collect
     assert_equal 10, answers["budgets"]["brainstorm"]
@@ -288,7 +310,7 @@ class InitPromptsTest < Minitest::Test
 
   def test_interactive_limits_malformed_format_reprompts
     # "30" without comma fails the <budget>,<timeout> shape → re-prompt
-    input = ([ "", "", "", "", "30", "30,900" ] + ([ "" ] * 10)).join("\n") + "\n"
+    input = ([ "", "", "", "", "30", "30,900" ] + ([ "" ] * 12)).join("\n") + "\n"
     prompts, output = make_prompts(input)
     answers = prompts.collect
     assert_equal 30, answers["budgets"]["brainstorm"]
@@ -465,7 +487,7 @@ class InitPromptsTest < Minitest::Test
     # Truncate the input transcript right before confirmation. read_line
     # must distinguish nil-from-gets (EOF) from an empty line and bubble
     # Aborted up the stack rather than silently confirming.
-    inputs = ([ "" ] * 14).join("\n") + "\n"  # 14 blank reads, then EOF
+    inputs = ([ "" ] * 16).join("\n") + "\n"  # 14 blank reads, then EOF
     prompts, _output, _summary = make_prompts(inputs)
     assert_raises(Hive::Commands::Init::Prompts::Aborted) { prompts.collect }
   end
@@ -494,7 +516,7 @@ class InitPromptsTest < Minitest::Test
   # validate_reviewers! rejects on the next `hive run`. Re-prompt instead.
   def test_reviewers_comma_only_reprompts
     # Trailing values are triage bias, nine limits, daemon, and confirm.
-    input = ([ "", "", ",", "1" ] + ([ "" ] * 12)).join("\n") + "\n"
+    input = ([ "", "", ",", "1" ] + ([ "" ] * 14)).join("\n") + "\n"
     prompts, output, _summary = make_prompts(input)
     answers = prompts.collect
     assert_equal %w[claude-ce-code-review], answers["enabled_reviewers"]
@@ -502,7 +524,7 @@ class InitPromptsTest < Minitest::Test
   end
 
   def test_reviewers_whitespace_only_reprompts
-    input = ([ "", "", "  ,  ,  ", "2" ] + ([ "" ] * 12)).join("\n") + "\n"
+    input = ([ "", "", "  ,  ,  ", "2" ] + ([ "" ] * 14)).join("\n") + "\n"
     prompts, output, _summary = make_prompts(input)
     answers = prompts.collect
     assert_equal %w[codex-ce-code-review], answers["enabled_reviewers"]
diff --git a/test/unit/commands/rebase_status_test.rb b/test/unit/commands/rebase_status_test.rb
index e24b734..f8772f8 100644
--- a/test/unit/commands/rebase_status_test.rb
+++ b/test/unit/commands/rebase_status_test.rb
@@ -15,7 +15,7 @@ class HiveCommandsRebaseStatusTest < Minitest::Test
 
   def make_task(worktree:, dir: nil)
     project_root = dir || Dir.mktmpdir("rebase-status-proj")
-    folder = File.join(project_root, ".hive-state", "stages", "4-execute", "demo-260514-aaaa")
+    folder = File.join(project_root, ".hive", "stages", "4-execute", "demo-260514-aaaa")
     FileUtils.mkdir_p(folder)
     FakeTask.new("demo-260514-aaaa", "4-execute", folder, worktree, project_root)
   end
diff --git a/test/unit/commands/status_diagnose_test.rb b/test/unit/commands/status_diagnose_test.rb
index df27ac4..e5c3f39 100644
--- a/test/unit/commands/status_diagnose_test.rb
+++ b/test/unit/commands/status_diagnose_test.rb
@@ -10,7 +10,7 @@ class StatusDiagnoseTest < Minitest::Test
   def with_review_task
     Dir.mktmpdir("hive-status-diagnose") do |project_root|
       slug = "red-task-260516-aaaa"
-      folder = File.join(project_root, ".hive-state", "stages", "6-review", slug)
+      folder = File.join(project_root, ".hive", "stages", "6-review", slug)
       FileUtils.mkdir_p(File.join(folder, "reviews"))
       File.write(File.join(folder, "task.md"), "<!-- REVIEW_ERROR phase=fix pass=1 -->\n")
       File.write(File.join(folder, "reviews", "errors-01.md"), "fix failed\n")
@@ -76,7 +76,7 @@ class StatusDiagnoseTest < Minitest::Test
     # PR #84 review finding #1.
     Dir.mktmpdir("hive-status-diagnose-green") do |project_root|
       slug = "green-task-260517-bbbb"
-      folder = File.join(project_root, ".hive-state", "stages", "3-plan", slug)
+      folder = File.join(project_root, ".hive", "stages", "3-plan", slug)
       FileUtils.mkdir_p(folder)
       File.write(File.join(folder, "task.md"), "<!-- COMPLETE -->\n")
 
@@ -176,7 +176,7 @@ class StatusDiagnoseTest < Minitest::Test
       project_b = File.join(home, "beta")
       slug = "shared-slug-260518-abcd"
       [ project_a, project_b ].each do |root|
-        folder = File.join(root, ".hive-state", "stages", "6-review", slug)
+        folder = File.join(root, ".hive", "stages", "6-review", slug)
         FileUtils.mkdir_p(folder)
         File.write(File.join(folder, "task.md"), "<!-- REVIEW_ERROR phase=fix pass=1 -->\n")
       end
diff --git a/test/unit/commands/uninstall_test.rb b/test/unit/commands/uninstall_test.rb
new file mode 100644
index 0000000..5229fd2
--- /dev/null
+++ b/test/unit/commands/uninstall_test.rb
@@ -0,0 +1,214 @@
+require "test_helper"
+require "hive/commands/uninstall"
+require "hive/install_receipt"
+require "stringio"
+require "hive/config"
+
+# U7 (plan figure-out-way-to-install-260513-4a0a): preserve-by-default
+# uninstall semantics — scenario D. All service-manager invocations are
+# stubbed; filesystem state lives inside the HIVE_HOME sandbox.
+class HiveCommandsUninstallTest < Minitest::Test
+  include HiveTestHelper
+
+  def setup
+    @out = StringIO.new
+    @err = StringIO.new
+  end
+
+  def ok_status
+    @ok_status ||= begin
+      system("true")
+      $CHILD_STATUS.clone
+    end
+  end
+
+  def with_uninstall_sandbox(receipt_data = nil)
+    with_tmp_dir do |dir|
+      saved = ENV["HIVE_HOME"]
+      ENV["HIVE_HOME"] = dir
+      Hive::InstallReceipt.write!(channel: "script", version: "v0.1.0") if receipt_data == :script
+      File.write(Hive::InstallReceipt.path, receipt_data.to_yaml) if receipt_data.is_a?(Hash)
+      yield dir
+    ensure
+      if saved.nil?
+        ENV.delete("HIVE_HOME")
+      else
+        ENV["HIVE_HOME"] = saved
+      end
+    end
+  end
+
+  def run_uninstall(input_text: nil, purge: false, runner: ->(*) { [ "", "", ok_status ] }, mutate: nil)
+    io = StringIO.new(input_text.to_s)
+    io.define_singleton_method(:tty?) { !input_text.nil? }
+    with_service_stubs do
+      cmd = Hive::Commands::Uninstall.new(
+        purge: purge, input: io, out: @out, err: @err, runner: runner
+      )
+      mutate&.call(cmd)
+      cmd.call
+    end
+  end
+
+  def with_service_stubs
+    Hive::Service.define_singleton_method(:unload!) do
+      @unload_calls ||= []
+      @unload_calls << true
+      !@unload_calls.empty?
+    end
+    Hive::Service.define_singleton_method(:remove_manifest!) do
+      @removed ||= []
+      @removed << true
+      true
+    end
+    yield
+  ensure
+    begin
+      Hive::Service.singleton_class.send(:remove_method, :unload!)
+      Hive::Service.singleton_class.send(:remove_method, :remove_manifest!)
+    rescue NameError
+      nil
+    end
+  end
+
+  def register_project_fixture(dir)
+    project_path = File.join(dir, "proj")
+    FileUtils.mkdir_p(File.join(project_path, ".hive", "stages"))
+    Hive::Config.register_project(name: "proj", path: project_path)
+    project_path
+  end
+
+  def test_non_tty_plain_prints_plan_and_changes_nothing
+    with_uninstall_sandbox(:script) do |dir|
+      project_path = register_project_fixture(dir)
+      run_uninstall
+
+      assert_match(/nothing has been changed/, @out.string)
+      assert File.directory?(File.join(project_path, ".hive")), "scaffold preserved"
+      assert File.exist?(Hive::InstallReceipt.path), "receipt preserved"
+      assert_includes @out.string, "✓ removed daemon service registration"
+      assert_includes @out.string, "Performed 1 change(s)"
+    end
+  end
+
+  def test_purge_removes_service_and_receipt_but_preserves_work
+    with_uninstall_sandbox({ "channel" => "brew", "version" => "v0.1.0" }) do |dir|
+      project_path = register_project_fixture(dir)
+      state_marker = File.join(project_path, ".hive", "stages", "keep.md")
+      File.write(state_marker, "work")
+      config_dir = Hive::Paths.config_dir
+      FileUtils.mkdir_p(config_dir)
+
+      run_uninstall(purge: true)
+
+      refute File.exist?(Hive::InstallReceipt.path), "receipt removed by purge"
+      assert File.directory?(project_path), "project work preserved"
+      assert File.exist?(state_marker), "task data preserved"
+      assert File.directory?(config_dir), "global config dir preserved on purge"
+      assert_includes @out.string, "keeps all project data"
+    end
+  end
+
+  def test_interactive_keep_everything_only_touches_service
+    with_uninstall_sandbox(:script) do |dir|
+      project_path = register_project_fixture(dir)
+      data_dir = Hive::Paths.state_dir
+      FileUtils.mkdir_p(data_dir)
+
+      run_uninstall(input_text: "\n\n") # keep prompt answers default
+
+      scaffold = File.join(project_path, ".hive")
+      assert File.directory?(scaffold), "project scaffold kept"
+      assert File.directory?(data_dir), "state kept"
+      assert File.exist?(Hive::InstallReceipt.path), "receipt kept in interactive keep flow"
+      assert_match(/✓ removed daemon service registration|no daemon service registration/, @out.string)
+    end
+  end
+
+  def test_interactive_project_removal_opt_in_deletes_scaffold_not_state
+    with_uninstall_sandbox do |dir|
+      project_path = register_project_fixture(dir)
+
+      run_uninstall(input_text: "remove\nN\n") # project remove, global keep
+
+      refute File.exist?(File.join(project_path, ".hive")), "opted-in scaffold deleted"
+      registry = Hive::Config.registered_projects
+      refute(registry.any? { |p| p["name"] == "proj" }, "registry row dropped")
+      assert File.directory?(Hive::Paths.config_dir), "global config untouched"
+    end
+  end
+
+  def test_brew_receipt_delegates_to_brew_uninstall
+    recorder = []
+    with_uninstall_sandbox({ "channel" => "brew", "version" => "v0.1.0" }) do
+      receipt_ok = {
+        "out" => "", "err" => "", "status" => ok_status
+      }
+      run_uninstall(runner: lambda do |*argv|
+        recorder << argv.map(&:to_s)
+        [ "", "", ok_status ]
+      end)
+      expected = %w[brew uninstall ivankuznetsov/hive/hive]
+      assert recorder.include?(expected), "recorded #{recorder.inspect}"
+    end
+  end
+
+  def test_aur_channel_delegates_via_sudo_pacman
+    recorder = []
+    with_uninstall_sandbox({ "channel" => "aur", "version" => "v0.1.0" }) do
+      # Craft an AUR channel explicitly and verify delegation shape.
+      run_uninstall(
+        runner: lambda do |*argv|
+          recorder << argv.map(&:to_s)
+          [ "", "", ok_status ]
+        end,
+        mutate: ->(cmd) { cmd.define_singleton_method(:binary_delegation_command) do
+          [ :aur, ["sudo", "pacman", "-Rns", "hive-bin"] ]
+        end }
+      )
+      assert(recorder.any? { |a| a == %w[sudo pacman -Rns hive-bin] },
+             "delegates to sudo pacman -Rns hive-bin; recorded #{recorder.inspect}")
+    end
+  end
+
+  def test_script_receipt_reverses_local_launcher_and_keeps_data
+    with_uninstall_sandbox(:script) do |dir|
+      bin_dir = File.join(dir, "bin")
+      share_dir = Hive::Paths.data_dir
+      FileUtils.mkdir_p(bin_dir)
+      FileUtils.mkdir_p(share_dir)
+      launcher = File.join(bin_dir, "hive")
+      begin
+        FileUtils.ln_sf(File.join(share_dir, "bin", "hive"), launcher)
+
+        saved_path = ENV["PATH"]
+        ENV["PATH"] = "#{bin_dir}:#{saved_path}"
+        ENV["HIVE_COMMAND_NAME"] = "hive"
+
+        run_uninstall(input_text: "\n\n")
+      ensure
+        ENV["PATH"] = saved_path
+        ENV.delete("HIVE_COMMAND_NAME")
+      end
+      state_dir = Hive::Paths.state_dir
+      assert File.directory?(state_dir), "script uninstall never touches data dirs"
+      assert_match(/launcher|No package|skipped/i, @out.string)
+    end
+  end
+
+  def test_command_name_honors_hive_env_override
+    ENV["HIVE_COMMAND_NAME"] = "hv"
+    begin
+      assert_equal "hv", Hive::Commands::Uninstall.command_name
+    ensure
+      ENV.delete("HIVE_COMMAND_NAME")
+    end
+  end
+
+  def test_skills_pointer_is_printed_and_never_removes_agent_dirs
+    with_uninstall_sandbox do
+      run_uninstall(purge: true)
+      assert_includes @out.string, "marketplace"
+    end
+  end
+end
diff --git a/test/unit/commands/update_test.rb b/test/unit/commands/update_test.rb
new file mode 100644
index 0000000..0622a52
--- /dev/null
+++ b/test/unit/commands/update_test.rb
@@ -0,0 +1,171 @@
+require "test_helper"
+require "hive/install_receipt"
+require "hive/commands/update"
+require "stringio"
+
+# U6 (plan figure-out-way-to-install-260513-4a0a): the per-channel install
+# receipt and the channel-aware `hive update` delegation. All channel
+# tooling is stubbed through an injectable runner; pacman/brew probes are
+# stubbed at Open3 where needed.
+class HiveCommandsUpdateTest < Minitest::Test
+  include HiveTestHelper
+
+  def setup
+    @out = StringIO.new
+    @err = StringIO.new
+  end
+
+  def with_receipt_sandbox(data = nil)
+    with_tmp_dir do |dir|
+      saved = ENV["HIVE_HOME"]
+      ENV["HIVE_HOME"] = dir
+      File.write(Hive::InstallReceipt.path, data.is_a?(Hash) ? data.to_yaml : data.to_s) if data
+      yield dir
+    ensure
+      if saved.nil?
+        ENV.delete("HIVE_HOME")
+      else
+        ENV["HIVE_HOME"] = saved
+      end
+    end
+  end
+
+  # ── Receipt shape ────────────────────────────────────────────────────
+
+  def test_write_roundtrip_with_defaults
+    with_receipt_sandbox do |_dir|
+      doc = Hive::InstallReceipt.write!(channel: "script", version: "v0.1.0")
+      parsed = Hive::InstallReceipt.read
+      assert_equal "script", parsed["channel"]
+      assert_equal "v0.1.0", parsed["version"]
+      assert_equal "hive", parsed["command_name"]
+      refute_nil parsed["installed_at"]
+      assert_equal({ "channel" => "script" }, { "channel" => doc["channel"] })
+    end
+  end
+
+  def test_read_rejects_unknown_channel
+    with_receipt_sandbox("channel: gem\n") do
+      err = assert_raises(Hive::InstallReceipt::InvalidError) do
+        Hive::InstallReceipt.read
+      end
+      assert_match(/invalid channel/, err.message)
+    end
+  end
+
+  def test_read_returns_nil_when_absent
+    with_receipt_sandbox do
+      assert_nil Hive::InstallReceipt.read
+    end
+  end
+
+  def test_forget_removes_the_file
+    with_receipt_sandbox("channel: script\n") do
+      assert_equal true, Hive::InstallReceipt.forget!
+      refute File.exist?(Hive::InstallReceipt.path)
+      assert_equal false, Hive::InstallReceipt.forget!
+    end
+  end
+
+  # ── Update delegation ────────────────────────────────────────────────
+
+  def ok_status
+    @ok_status ||= begin
+      system("true")
+      $CHILD_STATUS.clone
+    end
+  end
+
+  def command_stub(expected_argv, recorder)
+    lambda do |*argv|
+      recorder << argv.map(&:to_s)
+      ok = argv == expected_argv || argv.join(" ") == expected_argv.join(" ")
+      [ "", ok ? "" : "stub mismatch", ok ? ok_status : nil ]
+    end
+  end
+
+  def test_script_channel_shells_to_pinned_install_sh
+    recorder = []
+    expected = [
+      "sh", "-c",
+      "curl -fsSL https://github.com/ivankuznetsov/hive/releases/download/v0.1.0/install.sh | HIVE_VERSION=v0.1.0 bash"
+    ]
+    with_receipt_sandbox({ "channel" => "script", "version" => "v0.1.0" }) do
+      upd = Hive::Commands::Update.new(out: @out, runner: command_stub(expected, recorder))
+      code = upd.call
+      assert_equal 0, code
+      assert_includes @out.string, "$ curl -fsSL"
+      assert recorder.any? { |a| a[0] == "sh" }, "shell ran via sh -c"
+    end
+  end
+
+  def test_brew_channel_invokes_brew_upgrade_tap
+    recorder = []
+    expected = [ "brew", "upgrade", "ivankuznetsov/hive/hive" ]
+    with_receipt_sandbox({ "channel" => "brew", "version" => "v0.1.0" }) do
+      Hive::Commands::Update.new(out: @out, runner: command_stub(expected, recorder)).call
+      assert recorder.include?(expected), "recorded: #{recorder.inspect}"
+    end
+  end
+
+  def test_aur_channel_uses_detected_helper_and_never_plain_dash_s
+    recorder = []
+    with_receipt_sandbox({ "channel" => "aur", "version" => "v0.1.0" }) do
+      upd = Hive::Commands::Update.new(
+        out: @out,
+        runner: lambda do |*argv|
+          recorder << argv.map(&:to_s)
+          [ "", "", ok_status ]
+        end
+      )
+      upd.define_singleton_method(:helper_available?) do |name| name == "yay"; end
+      code = upd.call
+      assert_equal 0, code
+      line = recorder.find { |a| a.first == "yay" }
+      refute_nil line, "must run yay for -Syu hive-bin"
+      assert_includes line, "-Syu"
+      assert_includes line.join(" "), "hive-bin"
+      refute line.grep(/\A-S\z/).any?, "plain `-S` must never be used (system convention)"
+    end
+  end
+
+  def test_aur_without_helper_fails_loudly
+    with_receipt_sandbox({ "channel" => "aur", "version" => "v0.1.0" }) do
+      upd = Hive::Commands::Update.new(
+        out: @out,
+        runner: ->(*) { raise "should not run a helper" },
+        err: @err
+      )
+      upd.define_singleton_method(:helper_available?) { |_| false }
+      error = assert_raises(Hive::Error) { upd.call }
+      assert_match(/no AUR helper found/, error.message)
+    end
+  end
+
+  def test_no_receipt_is_dev_mode_exit_zero
+    with_receipt_sandbox do
+      upd = Hive::Commands::Update.new(out: @out, err: @err)
+      # Kill both the PATH probe and fallback detection so nothing can fire.
+      upd.define_singleton_method(:found_command) { nil }
+      upd.define_singleton_method(:current_version_line) { nil }
+      orig_detect = Hive::InstallReceipt.method(:detect_fallback)
+      Hive::InstallReceipt.define_singleton_method(:detect_fallback) { |_| nil }
+
+      _, source = Hive::InstallReceipt.resolve("/nonexistent/hive-probe-target")
+      assert_equal :none, source
+
+      result = nil
+      _out, _err = capture_io { result = upd.call }
+      assert_equal 0, result
+    ensure
+      Hive::InstallReceipt.define_singleton_method(:detect_fallback, orig_detect)
+    end
+  end
+
+  def test_refuses_root_unless_env_flag
+    src = File.read(File.expand_path("../../../lib/hive/commands/update.rb", __dir__))
+    assert_includes src, "Process.uid != 0 && Process.euid != 0"
+    assert_includes src, "HIVE_ALLOW_ROOT_UPDATE"
+    assert_match(/refusing to run `hive update` as root/, src)
+  end
+end
